﻿namespace IcqSharp
{
    public enum SignonError : byte
    {
        // OK
        NoError = 0x00,

        // Wrong UIN/Password
        UnregisteredUin = 0x01,
        IncorrectUinOrPassword = 0x04,
        MismatchUinOrPassword = 0x05,
        InternalClientError = 0x06,
        InvalidAccount = 0x07,

        // Service unavailable
        ServiceUnavailable = 0x02,
        ServiceTemporarilyOffline = 0x10,
        BadDatabaseStatus = 0x0D,
        DatabaseSendError = 0x12,
        ReservationMapError = 0x14,
        ReservationLinkError = 0x15,
        ReservationTimeout = 0x1A,

        // Too many connections
        MaxConnectionsFromIP = 0x16,
        MaxConnectionsFromIP2 = 0x17,

        // Too quickly connected
        ReservationRateLimitExceeded = 0x18,
        RateLimitExceeded = 0x1D,

        // Old client version (fatal)
        VersionUpgradeRequired = 0x1B,

        // Old client version (notify)
        VersionUpgradeRecommended = 0x1C,

        // Can't register on the ICQ network
        CantRegisterOnNetwork = 0x1E,

        // MD5 login not supported
        MD5NotSupported = 0x0C,

        // Other errors
        DeletedAccount = 0x08,
        ExpiredAccount = 0x09,
        NoAccessToDatabase = 0x0A,
        NoAccessToResolver = 0x0B,
        BadResolverStatus = 0x0E,
        InternalError = 0x0F,
        SuspendedAccount = 0x11,
        DatabaseLinkError = 0x13,
        UserTooHeavilyWarned = 0x19,
        TokenServerTimeout = 0x1F,
        InvalidSecureIdNumber = 0x20,
        McError = 0x21,
        AgeRestriction = 0x22,
        RequireRevalidation = 0x23,
        LinkRuleRejected = 0x24,
        BadSnacFormat = 0x25,
        LinkBroken = 0x26,
        InvalidClientIP = 0x27,
        PartnerRejected = 0x28,
        SecureIdMissing = 0x29,
        BlockedAccount = 0x2A
    }

}
